/*
 * (C) Copyright 2008-2017 Fuzhou Rockchip Electronics Co., Ltd
 *
 * SPDX-License-Identifier:	GPL-2.0+
 */

#include <drm/drm_mipi_dsi.h>

#include <config.h>
#include <common.h>
#include <errno.h>
#include <malloc.h>
#include <video.h>
#include <backlight.h>
#include <asm/gpio.h>
#include <dm/device.h>
#include <dm/read.h>
#include <dm/uclass.h>
#include <dm/uclass-id.h>
#include <linux/media-bus-format.h>
#include <power/regulator.h>

#include "rockchip_display.h"
#include "rockchip_crtc.h"
#include "rockchip_connector.h"
#include "rockchip_panel.h"

struct rockchip_panel_cmds {
	u8 data[32];
};

struct radxa_panel_desc {
	const struct drm_display_mode mode;
	unsigned int bpc;
	unsigned int format;
	struct rockchip_panel_cmds *on_cmds;
	struct rockchip_panel_cmds *off_cmds;
	u32 num_init_cmds;
};

struct rockchip_panel_priv {
	bool prepared;
	bool enabled;
	struct udevice *power_supply;
	struct udevice *vccio;
	struct udevice *vdd;
	struct udevice *backlight;
	struct gpio_desc enable_gpio;
	struct gpio_desc reset_gpio;

	int cmd_type;
	struct gpio_desc spi_sdi_gpio;
	struct gpio_desc spi_scl_gpio;
	struct gpio_desc spi_cs_gpio;

	struct radxa_panel_desc *desc;
};

static struct rockchip_panel_cmds radxa_8hd_init_cmd[] = {
	{ .data = {0x15,0x00,0x02,0xE0, 0x00 } },
	{ .data = {0x15,0x00,0x02,0xE1, 0x93 } },
	{ .data = {0x15,0x00,0x02,0xE2, 0x65 } },
	{ .data = {0x15,0x00,0x02,0xE3, 0xF8 } },
	{ .data = {0x15,0x00,0x02,0x80, 0x03 } },
	{ .data = {0x15,0x00,0x02,0xE0, 0x01 } },
	{ .data = {0x15,0x00,0x02,0x00, 0x00 } },
	{ .data = {0x15,0x00,0x02,0x01, 0x7E } },
	{ .data = {0x15,0x00,0x02,0x03, 0x00 } },
	{ .data = {0x15,0x00,0x02,0x04, 0x65 } },
	{ .data = {0x15,0x00,0x02,0x0C, 0x74 } },
	{ .data = {0x15,0x00,0x02,0x17, 0x00 } },
	{ .data = {0x15,0x00,0x02,0x18, 0xB7 } },
	{ .data = {0x15,0x00,0x02,0x19, 0x00 } },
	{ .data = {0x15,0x00,0x02,0x1A, 0x00 } },
	{ .data = {0x15,0x00,0x02,0x1B, 0xB7 } },
	{ .data = {0x15,0x00,0x02,0x1C, 0x00 } },
	{ .data = {0x15,0x00,0x02,0x24, 0xFE } },
	{ .data = {0x15,0x00,0x02,0x37, 0x19 } },
	{ .data = {0x15,0x00,0x02,0x38, 0x05 } },
	{ .data = {0x15,0x00,0x02,0x39, 0x00 } },
	{ .data = {0x15,0x00,0x02,0x3A, 0x01 } },
	{ .data = {0x15,0x00,0x02,0x3B, 0x01 } },
	{ .data = {0x15,0x00,0x02,0x3C, 0x70 } },
	{ .data = {0x15,0x00,0x02,0x3D, 0xFF } },
	{ .data = {0x15,0x00,0x02,0x3E, 0xFF } },
	{ .data = {0x15,0x00,0x02,0x3F, 0xFF } },
	{ .data = {0x15,0x00,0x02,0x40, 0x06 } },
	{ .data = {0x15,0x00,0x02,0x41, 0xA0 } },
	{ .data = {0x15,0x00,0x02,0x43, 0x1E } },
	{ .data = {0x15,0x00,0x02,0x44, 0x0F } },
	{ .data = {0x15,0x00,0x02,0x45, 0x28 } },
	{ .data = {0x15,0x00,0x02,0x4B, 0x04 } },
	{ .data = {0x15,0x00,0x02,0x55, 0x02 } },
	{ .data = {0x15,0x00,0x02,0x56, 0x01 } },
	{ .data = {0x15,0x00,0x02,0x57, 0xA9 } },
	{ .data = {0x15,0x00,0x02,0x58, 0x0A } },
	{ .data = {0x15,0x00,0x02,0x59, 0x0A } },
	{ .data = {0x15,0x00,0x02,0x5A, 0x37 } },
	{ .data = {0x15,0x00,0x02,0x5B, 0x19 } },
	{ .data = {0x15,0x00,0x02,0x5D, 0x78 } },
	{ .data = {0x15,0x00,0x02,0x5E, 0x63 } },
	{ .data = {0x15,0x00,0x02,0x5F, 0x54 } },
	{ .data = {0x15,0x00,0x02,0x60, 0x49 } },
	{ .data = {0x15,0x00,0x02,0x61, 0x45 } },
	{ .data = {0x15,0x00,0x02,0x62, 0x38 } },
	{ .data = {0x15,0x00,0x02,0x63, 0x3D } },
	{ .data = {0x15,0x00,0x02,0x64, 0x28 } },
	{ .data = {0x15,0x00,0x02,0x65, 0x43 } },
	{ .data = {0x15,0x00,0x02,0x66, 0x41 } },
	{ .data = {0x15,0x00,0x02,0x67, 0x43 } },
	{ .data = {0x15,0x00,0x02,0x68, 0x62 } },
	{ .data = {0x15,0x00,0x02,0x69, 0x50 } },
	{ .data = {0x15,0x00,0x02,0x6A, 0x57 } },
	{ .data = {0x15,0x00,0x02,0x6B, 0x49 } },
	{ .data = {0x15,0x00,0x02,0x6C, 0x44 } },
	{ .data = {0x15,0x00,0x02,0x6D, 0x37 } },
	{ .data = {0x15,0x00,0x02,0x6E, 0x23 } },
	{ .data = {0x15,0x00,0x02,0x6F, 0x10 } },
	{ .data = {0x15,0x00,0x02,0x70, 0x78 } },
	{ .data = {0x15,0x00,0x02,0x71, 0x63 } },
	{ .data = {0x15,0x00,0x02,0x72, 0x54 } },
	{ .data = {0x15,0x00,0x02,0x73, 0x49 } },
	{ .data = {0x15,0x00,0x02,0x74, 0x45 } },
	{ .data = {0x15,0x00,0x02,0x75, 0x38 } },
	{ .data = {0x15,0x00,0x02,0x76, 0x3D } },
	{ .data = {0x15,0x00,0x02,0x77, 0x28 } },
	{ .data = {0x15,0x00,0x02,0x78, 0x43 } },
	{ .data = {0x15,0x00,0x02,0x79, 0x41 } },
	{ .data = {0x15,0x00,0x02,0x7A, 0x43 } },
	{ .data = {0x15,0x00,0x02,0x7B, 0x62 } },
	{ .data = {0x15,0x00,0x02,0x7C, 0x50 } },
	{ .data = {0x15,0x00,0x02,0x7D, 0x57 } },
	{ .data = {0x15,0x00,0x02,0x7E, 0x49 } },
	{ .data = {0x15,0x00,0x02,0x7F, 0x44 } },
	{ .data = {0x15,0x00,0x02,0x80, 0x37 } },
	{ .data = {0x15,0x00,0x02,0x81, 0x23 } },
	{ .data = {0x15,0x00,0x02,0x82, 0x10 } },
	{ .data = {0x15,0x00,0x02,0xE0, 0x02 } },
	{ .data = {0x15,0x00,0x02,0x00, 0x47 } },
	{ .data = {0x15,0x00,0x02,0x01, 0x47 } },
	{ .data = {0x15,0x00,0x02,0x02, 0x45 } },
	{ .data = {0x15,0x00,0x02,0x03, 0x45 } },
	{ .data = {0x15,0x00,0x02,0x04, 0x4B } },
	{ .data = {0x15,0x00,0x02,0x05, 0x4B } },
	{ .data = {0x15,0x00,0x02,0x06, 0x49 } },
	{ .data = {0x15,0x00,0x02,0x07, 0x49 } },
	{ .data = {0x15,0x00,0x02,0x08, 0x41 } },
	{ .data = {0x15,0x00,0x02,0x09, 0x1F } },
	{ .data = {0x15,0x00,0x02,0x0A, 0x1F } },
	{ .data = {0x15,0x00,0x02,0x0B, 0x1F } },
	{ .data = {0x15,0x00,0x02,0x0C, 0x1F } },
	{ .data = {0x15,0x00,0x02,0x0D, 0x1F } },
	{ .data = {0x15,0x00,0x02,0x0E, 0x1F } },
	{ .data = {0x15,0x00,0x02,0x0F, 0x5F } },
	{ .data = {0x15,0x00,0x02,0x10, 0x5F } },
	{ .data = {0x15,0x00,0x02,0x11, 0x57 } },
	{ .data = {0x15,0x00,0x02,0x12, 0x77 } },
	{ .data = {0x15,0x00,0x02,0x13, 0x35 } },
	{ .data = {0x15,0x00,0x02,0x14, 0x1F } },
	{ .data = {0x15,0x00,0x02,0x15, 0x1F } },
	{ .data = {0x15,0x00,0x02,0x16, 0x46 } },
	{ .data = {0x15,0x00,0x02,0x17, 0x46 } },
	{ .data = {0x15,0x00,0x02,0x18, 0x44 } },
	{ .data = {0x15,0x00,0x02,0x19, 0x44 } },
	{ .data = {0x15,0x00,0x02,0x1A, 0x4A } },
	{ .data = {0x15,0x00,0x02,0x1B, 0x4A } },
	{ .data = {0x15,0x00,0x02,0x1C, 0x48 } },
	{ .data = {0x15,0x00,0x02,0x1D, 0x48 } },
	{ .data = {0x15,0x00,0x02,0x1E, 0x40 } },
	{ .data = {0x15,0x00,0x02,0x1F, 0x1F } },
	{ .data = {0x15,0x00,0x02,0x20, 0x1F } },
	{ .data = {0x15,0x00,0x02,0x21, 0x1F } },
	{ .data = {0x15,0x00,0x02,0x22, 0x1F } },
	{ .data = {0x15,0x00,0x02,0x23, 0x1F } },
	{ .data = {0x15,0x00,0x02,0x24, 0x1F } },
	{ .data = {0x15,0x00,0x02,0x25, 0x5F } },
	{ .data = {0x15,0x00,0x02,0x26, 0x5F } },
	{ .data = {0x15,0x00,0x02,0x27, 0x57 } },
	{ .data = {0x15,0x00,0x02,0x28, 0x77 } },
	{ .data = {0x15,0x00,0x02,0x29, 0x35 } },
	{ .data = {0x15,0x00,0x02,0x2A, 0x1F } },
	{ .data = {0x15,0x00,0x02,0x2B, 0x1F } },
	{ .data = {0x15,0x00,0x02,0x58, 0x40 } },
	{ .data = {0x15,0x00,0x02,0x59, 0x00 } },
	{ .data = {0x15,0x00,0x02,0x5A, 0x00 } },
	{ .data = {0x15,0x00,0x02,0x5B, 0x10 } },
	{ .data = {0x15,0x00,0x02,0x5C, 0x06 } },
	{ .data = {0x15,0x00,0x02,0x5D, 0x40 } },
	{ .data = {0x15,0x00,0x02,0x5E, 0x01 } },
	{ .data = {0x15,0x00,0x02,0x5F, 0x02 } },
	{ .data = {0x15,0x00,0x02,0x60, 0x30 } },
	{ .data = {0x15,0x00,0x02,0x61, 0x01 } },
	{ .data = {0x15,0x00,0x02,0x62, 0x02 } },
	{ .data = {0x15,0x00,0x02,0x63, 0x03 } },
	{ .data = {0x15,0x00,0x02,0x64, 0x6B } },
	{ .data = {0x15,0x00,0x02,0x65, 0x05 } },
	{ .data = {0x15,0x00,0x02,0x66, 0x0C } },
	{ .data = {0x15,0x00,0x02,0x67, 0x73 } },
	{ .data = {0x15,0x00,0x02,0x68, 0x09 } },
	{ .data = {0x15,0x00,0x02,0x69, 0x03 } },
	{ .data = {0x15,0x00,0x02,0x6A, 0x56 } },
	{ .data = {0x15,0x00,0x02,0x6B, 0x08 } },
	{ .data = {0x15,0x00,0x02,0x6C, 0x00 } },
	{ .data = {0x15,0x00,0x02,0x6D, 0x04 } },
	{ .data = {0x15,0x00,0x02,0x6E, 0x04 } },
	{ .data = {0x15,0x00,0x02,0x6F, 0x88 } },
	{ .data = {0x15,0x00,0x02,0x70, 0x00 } },
	{ .data = {0x15,0x00,0x02,0x71, 0x00 } },
	{ .data = {0x15,0x00,0x02,0x72, 0x06 } },
	{ .data = {0x15,0x00,0x02,0x73, 0x7B } },
	{ .data = {0x15,0x00,0x02,0x74, 0x00 } },
	{ .data = {0x15,0x00,0x02,0x75, 0xF8 } },
	{ .data = {0x15,0x00,0x02,0x76, 0x00 } },
	{ .data = {0x15,0x00,0x02,0x77, 0xD5 } },
	{ .data = {0x15,0x00,0x02,0x78, 0x2E } },
	{ .data = {0x15,0x00,0x02,0x79, 0x12 } },
	{ .data = {0x15,0x00,0x02,0x7A, 0x03 } },
	{ .data = {0x15,0x00,0x02,0x7B, 0x00 } },
	{ .data = {0x15,0x00,0x02,0x7C, 0x00 } },
	{ .data = {0x15,0x00,0x02,0x7D, 0x03 } },
	{ .data = {0x15,0x00,0x02,0x7E, 0x7B } },
	{ .data = {0x15,0x00,0x02,0xE0, 0x04 } },
	{ .data = {0x15,0x00,0x02,0x00, 0x0E } },
	{ .data = {0x15,0x00,0x02,0x02, 0xB3 } },
	{ .data = {0x15,0x00,0x02,0x09, 0x60 } },
	{ .data = {0x15,0x00,0x02,0x0E, 0x2A } },
	{ .data = {0x15,0x00,0x02,0x36, 0x59 } },
	{ .data = {0x15,0x00,0x02,0xE0, 0x00 } },
	{ .data = {0x05,0x78,0x01,0x11 } } ,
	{ .data = {0x05,0x14,0x01,0x29 } },
};

static struct rockchip_panel_cmds radxa_off_cmd[] = {
	{ .data = {0x05,0x00,0x01,0x28 } },
	{ .data = {0x05,0x00,0x01,0x10 } },
};

static struct radxa_panel_desc radxa_panel_desc_8hd = {
	.mode = {
		.clock		= 70000,

		.hdisplay	= 800,
		.hsync_start	= 800 + 40,
		.hsync_end	= 800 + 40 + 18,
		.htotal		= 800 + 40 + 18 + 20,

		.vdisplay	= 1280,
		.vsync_start	= 1280 + 20,
		.vsync_end	= 1280 + 20 + 4,
		.vtotal		= 1280 + 20 + 4 + 20,

		.flags = DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC,
	},
	.bpc = 8,
	.format = MEDIA_BUS_FMT_RBG888_1X24,
	.on_cmds = radxa_8hd_init_cmd,
	.off_cmds = radxa_off_cmd,
	.num_init_cmds = sizeof(radxa_8hd_init_cmd)/sizeof(struct rockchip_panel_cmds),
};

static struct rockchip_panel_cmds radxa_10hd_init_cmd[] = {
	{ .data = {0x15,0x00,0x02, 0xE0, 0x00 } },
	{ .data = {0x15,0x00,0x02, 0xE1, 0x93 } },
	{ .data = {0x15,0x00,0x02, 0xE2, 0x65 } },
	{ .data = {0x15,0x00,0x02, 0xE3, 0xF8 } },
	{ .data = {0x15,0x00,0x02, 0x80, 0x03 } },
	{ .data = {0x15,0x00,0x02, 0xE0, 0x01 } },
	{ .data = {0x15,0x00,0x02, 0x00, 0x00 } },
	{ .data = {0x15,0x00,0x02, 0x01, 0x3B } },
	{ .data = {0x15,0x00,0x02, 0x0C, 0x74 } },
	{ .data = {0x15,0x00,0x02, 0x17, 0x00 } },
	{ .data = {0x15,0x00,0x02, 0x18, 0xAF } },
	{ .data = {0x15,0x00,0x02, 0x19, 0x00 } },
	{ .data = {0x15,0x00,0x02, 0x1A, 0x00 } },
	{ .data = {0x15,0x00,0x02, 0x1B, 0xAF } },
	{ .data = {0x15,0x00,0x02, 0x1C, 0x00 } },
	{ .data = {0x15,0x00,0x02, 0x35, 0x26 } },
	{ .data = {0x15,0x00,0x02, 0x37, 0x09 } },
	{ .data = {0x15,0x00,0x02, 0x38, 0x04 } },
	{ .data = {0x15,0x00,0x02, 0x39, 0x00 } },
	{ .data = {0x15,0x00,0x02, 0x3A, 0x01 } },
	{ .data = {0x15,0x00,0x02, 0x3C, 0x78 } },
	{ .data = {0x15,0x00,0x02, 0x3D, 0xFF } },
	{ .data = {0x15,0x00,0x02, 0x3E, 0xFF } },
	{ .data = {0x15,0x00,0x02, 0x3F, 0x7F } },
	{ .data = {0x15,0x00,0x02, 0x40, 0x06 } },
	{ .data = {0x15,0x00,0x02, 0x41, 0xA0 } },
	{ .data = {0x15,0x00,0x02, 0x42, 0x81 } },
	{ .data = {0x15,0x00,0x02, 0x43, 0x14 } },
	{ .data = {0x15,0x00,0x02, 0x44, 0x23 } },
	{ .data = {0x15,0x00,0x02, 0x45, 0x28 } },
	{ .data = {0x15,0x00,0x02, 0x55, 0x02 } },
	{ .data = {0x15,0x00,0x02, 0x57, 0x69 } },
	{ .data = {0x15,0x00,0x02, 0x59, 0x0A } },
	{ .data = {0x15,0x00,0x02, 0x5A, 0x2A } },
	{ .data = {0x15,0x00,0x02, 0x5B, 0x17 } },
	{ .data = {0x15,0x00,0x02, 0x5D, 0x7F } },
	{ .data = {0x15,0x00,0x02, 0x5E, 0x6B } },
	{ .data = {0x15,0x00,0x02, 0x5F, 0x5C } },
	{ .data = {0x15,0x00,0x02, 0x60, 0x4F } },
	{ .data = {0x15,0x00,0x02, 0x61, 0x4D } },
	{ .data = {0x15,0x00,0x02, 0x62, 0x3F } },
	{ .data = {0x15,0x00,0x02, 0x63, 0x42 } },
	{ .data = {0x15,0x00,0x02, 0x64, 0x2B } },
	{ .data = {0x15,0x00,0x02, 0x65, 0x44 } },
	{ .data = {0x15,0x00,0x02, 0x66, 0x43 } },
	{ .data = {0x15,0x00,0x02, 0x67, 0x43 } },
	{ .data = {0x15,0x00,0x02, 0x68, 0x63 } },
	{ .data = {0x15,0x00,0x02, 0x69, 0x52 } },
	{ .data = {0x15,0x00,0x02, 0x6A, 0x5A } },
	{ .data = {0x15,0x00,0x02, 0x6B, 0x4F } },
	{ .data = {0x15,0x00,0x02, 0x6C, 0x4E } },
	{ .data = {0x15,0x00,0x02, 0x6D, 0x20 } },
	{ .data = {0x15,0x00,0x02, 0x6E, 0x0F } },
	{ .data = {0x15,0x00,0x02, 0x6F, 0x00 } },
	{ .data = {0x15,0x00,0x02, 0x70, 0x7F } },
	{ .data = {0x15,0x00,0x02, 0x71, 0x6B } },
	{ .data = {0x15,0x00,0x02, 0x72, 0x5C } },
	{ .data = {0x15,0x00,0x02, 0x73, 0x4F } },
	{ .data = {0x15,0x00,0x02, 0x74, 0x4D } },
	{ .data = {0x15,0x00,0x02, 0x75, 0x3F } },
	{ .data = {0x15,0x00,0x02, 0x76, 0x42 } },
	{ .data = {0x15,0x00,0x02, 0x77, 0x2B } },
	{ .data = {0x15,0x00,0x02, 0x78, 0x44 } },
	{ .data = {0x15,0x00,0x02, 0x79, 0x43 } },
	{ .data = {0x15,0x00,0x02, 0x7A, 0x43 } },
	{ .data = {0x15,0x00,0x02, 0x7B, 0x63 } },
	{ .data = {0x15,0x00,0x02, 0x7C, 0x52 } },
	{ .data = {0x15,0x00,0x02, 0x7D, 0x5A } },
	{ .data = {0x15,0x00,0x02, 0x7E, 0x4F } },
	{ .data = {0x15,0x00,0x02, 0x7F, 0x4E } },
	{ .data = {0x15,0x00,0x02, 0x80, 0x20 } },
	{ .data = {0x15,0x00,0x02, 0x81, 0x0F } },
	{ .data = {0x15,0x00,0x02, 0x82, 0x00 } },
	{ .data = {0x15,0x00,0x02, 0xE0, 0x02 } },
	{ .data = {0x15,0x00,0x02, 0x00, 0x02 } },
	{ .data = {0x15,0x00,0x02, 0x01, 0x02 } },
	{ .data = {0x15,0x00,0x02, 0x02, 0x00 } },
	{ .data = {0x15,0x00,0x02, 0x03, 0x00 } },
	{ .data = {0x15,0x00,0x02, 0x04, 0x1E } },
	{ .data = {0x15,0x00,0x02, 0x05, 0x1E } },
	{ .data = {0x15,0x00,0x02, 0x06, 0x1F } },
	{ .data = {0x15,0x00,0x02, 0x07, 0x1F } },
	{ .data = {0x15,0x00,0x02, 0x08, 0x1F } },
	{ .data = {0x15,0x00,0x02, 0x09, 0x17 } },
	{ .data = {0x15,0x00,0x02, 0x0A, 0x17 } },
	{ .data = {0x15,0x00,0x02, 0x0B, 0x37 } },
	{ .data = {0x15,0x00,0x02, 0x0C, 0x37 } },
	{ .data = {0x15,0x00,0x02, 0x0D, 0x47 } },
	{ .data = {0x15,0x00,0x02, 0x0E, 0x47 } },
	{ .data = {0x15,0x00,0x02, 0x0F, 0x45 } },
	{ .data = {0x15,0x00,0x02, 0x10, 0x45 } },
	{ .data = {0x15,0x00,0x02, 0x11, 0x4B } },
	{ .data = {0x15,0x00,0x02, 0x12, 0x4B } },
	{ .data = {0x15,0x00,0x02, 0x13, 0x49 } },
	{ .data = {0x15,0x00,0x02, 0x14, 0x49 } },
	{ .data = {0x15,0x00,0x02, 0x15, 0x1F } },
	{ .data = {0x15,0x00,0x02, 0x16, 0x01 } },
	{ .data = {0x15,0x00,0x02, 0x17, 0x01 } },
	{ .data = {0x15,0x00,0x02, 0x18, 0x00 } },
	{ .data = {0x15,0x00,0x02, 0x19, 0x00 } },
	{ .data = {0x15,0x00,0x02, 0x1A, 0x1E } },
	{ .data = {0x15,0x00,0x02, 0x1B, 0x1E } },
	{ .data = {0x15,0x00,0x02, 0x1C, 0x1F } },
	{ .data = {0x15,0x00,0x02, 0x1D, 0x1F } },
	{ .data = {0x15,0x00,0x02, 0x1E, 0x1F } },
	{ .data = {0x15,0x00,0x02, 0x1F, 0x17 } },
	{ .data = {0x15,0x00,0x02, 0x20, 0x17 } },
	{ .data = {0x15,0x00,0x02, 0x21, 0x37 } },
	{ .data = {0x15,0x00,0x02, 0x22, 0x37 } },
	{ .data = {0x15,0x00,0x02, 0x23, 0x46 } },
	{ .data = {0x15,0x00,0x02, 0x24, 0x46 } },
	{ .data = {0x15,0x00,0x02, 0x25, 0x44 } },
	{ .data = {0x15,0x00,0x02, 0x26, 0x44 } },
	{ .data = {0x15,0x00,0x02, 0x27, 0x4A } },
	{ .data = {0x15,0x00,0x02, 0x28, 0x4A } },
	{ .data = {0x15,0x00,0x02, 0x29, 0x48 } },
	{ .data = {0x15,0x00,0x02, 0x2A, 0x48 } },
	{ .data = {0x15,0x00,0x02, 0x2B, 0x1F } },
	{ .data = {0x15,0x00,0x02, 0x2C, 0x01 } },
	{ .data = {0x15,0x00,0x02, 0x2D, 0x01 } },
	{ .data = {0x15,0x00,0x02, 0x2E, 0x00 } },
	{ .data = {0x15,0x00,0x02, 0x2F, 0x00 } },
	{ .data = {0x15,0x00,0x02, 0x30, 0x1F } },
	{ .data = {0x15,0x00,0x02, 0x31, 0x1F } },
	{ .data = {0x15,0x00,0x02, 0x32, 0x1E } },
	{ .data = {0x15,0x00,0x02, 0x33, 0x1E } },
	{ .data = {0x15,0x00,0x02, 0x34, 0x1F } },
	{ .data = {0x15,0x00,0x02, 0x35, 0x17 } },
	{ .data = {0x15,0x00,0x02, 0x36, 0x17 } },
	{ .data = {0x15,0x00,0x02, 0x37, 0x37 } },
	{ .data = {0x15,0x00,0x02, 0x38, 0x37 } },
	{ .data = {0x15,0x00,0x02, 0x39, 0x08 } },
	{ .data = {0x15,0x00,0x02, 0x3A, 0x08 } },
	{ .data = {0x15,0x00,0x02, 0x3B, 0x0A } },
	{ .data = {0x15,0x00,0x02, 0x3C, 0x0A } },
	{ .data = {0x15,0x00,0x02, 0x3D, 0x04 } },
	{ .data = {0x15,0x00,0x02, 0x3E, 0x04 } },
	{ .data = {0x15,0x00,0x02, 0x3F, 0x06 } },
	{ .data = {0x15,0x00,0x02, 0x40, 0x06 } },
	{ .data = {0x15,0x00,0x02, 0x41, 0x1F } },
	{ .data = {0x15,0x00,0x02, 0x42, 0x02 } },
	{ .data = {0x15,0x00,0x02, 0x43, 0x02 } },
	{ .data = {0x15,0x00,0x02, 0x44, 0x00 } },
	{ .data = {0x15,0x00,0x02, 0x45, 0x00 } },
	{ .data = {0x15,0x00,0x02, 0x46, 0x1F } },
	{ .data = {0x15,0x00,0x02, 0x47, 0x1F } },
	{ .data = {0x15,0x00,0x02, 0x48, 0x1E } },
	{ .data = {0x15,0x00,0x02, 0x49, 0x1E } },
	{ .data = {0x15,0x00,0x02, 0x4A, 0x1F } },
	{ .data = {0x15,0x00,0x02, 0x4B, 0x17 } },
	{ .data = {0x15,0x00,0x02, 0x4C, 0x17 } },
	{ .data = {0x15,0x00,0x02, 0x4D, 0x37 } },
	{ .data = {0x15,0x00,0x02, 0x4E, 0x37 } },
	{ .data = {0x15,0x00,0x02, 0x4F, 0x09 } },
	{ .data = {0x15,0x00,0x02, 0x50, 0x09 } },
	{ .data = {0x15,0x00,0x02, 0x51, 0x0B } },
	{ .data = {0x15,0x00,0x02, 0x52, 0x0B } },
	{ .data = {0x15,0x00,0x02, 0x53, 0x05 } },
	{ .data = {0x15,0x00,0x02, 0x54, 0x05 } },
	{ .data = {0x15,0x00,0x02, 0x55, 0x07 } },
	{ .data = {0x15,0x00,0x02, 0x56, 0x07 } },
	{ .data = {0x15,0x00,0x02, 0x57, 0x1F } },
	{ .data = {0x15,0x00,0x02, 0x58, 0x40 } },
	{ .data = {0x15,0x00,0x02, 0x5B, 0x30 } },
	{ .data = {0x15,0x00,0x02, 0x5C, 0x16 } },
	{ .data = {0x15,0x00,0x02, 0x5D, 0x34 } },
	{ .data = {0x15,0x00,0x02, 0x5E, 0x05 } },
	{ .data = {0x15,0x00,0x02, 0x5F, 0x02 } },
	{ .data = {0x15,0x00,0x02, 0x63, 0x00 } },
	{ .data = {0x15,0x00,0x02, 0x64, 0x6A } },
	{ .data = {0x15,0x00,0x02, 0x67, 0x73 } },
	{ .data = {0x15,0x00,0x02, 0x68, 0x1D } },
	{ .data = {0x15,0x00,0x02, 0x69, 0x08 } },
	{ .data = {0x15,0x00,0x02, 0x6A, 0x6A } },
	{ .data = {0x15,0x00,0x02, 0x6B, 0x08 } },
	{ .data = {0x15,0x00,0x02, 0x6C, 0x00 } },
	{ .data = {0x15,0x00,0x02, 0x6D, 0x00 } },
	{ .data = {0x15,0x00,0x02, 0x6E, 0x00 } },
	{ .data = {0x15,0x00,0x02, 0x6F, 0x88 } },
	{ .data = {0x15,0x00,0x02, 0x75, 0xFF } },
	{ .data = {0x15,0x00,0x02, 0x77, 0xDD } },
	{ .data = {0x15,0x00,0x02, 0x78, 0x3F } },
	{ .data = {0x15,0x00,0x02, 0x79, 0x15 } },
	{ .data = {0x15,0x00,0x02, 0x7A, 0x17 } },
	{ .data = {0x15,0x00,0x02, 0x7D, 0x14 } },
	{ .data = {0x15,0x00,0x02, 0x7E, 0x82 } },
	{ .data = {0x15,0x00,0x02, 0xE0, 0x04 } },
	{ .data = {0x15,0x00,0x02, 0x00, 0x0E } },
	{ .data = {0x15,0x00,0x02, 0x02, 0xB3 } },
	{ .data = {0x15,0x00,0x02, 0x09, 0x61 } },
	{ .data = {0x15,0x00,0x02, 0x0E, 0x48 } },
	{ .data = {0x15,0x00,0x02, 0xE0, 0x00 } },
	{ .data = {0x15,0x00,0x02, 0xE6, 0x02 } },
	{ .data = {0x15,0x00,0x02, 0xE7, 0x0C } },
	{ .data = {0x05,0x78,0x01,0x11 } } ,
	{ .data = {0x05,0x14,0x01,0x29 } },
};

static struct radxa_panel_desc radxa_panel_desc_10hd = {
	.mode = {
		.clock		= 70000,

		.hdisplay	= 800,
		.hsync_start	= 800 + 40,
		.hsync_end	= 800 + 40 + 18,
		.htotal		= 800 + 40 + 18 + 20,

		.vdisplay	= 1280,
		.vsync_start	= 1280 + 20,
		.vsync_end	= 1280 + 20 + 4,
		.vtotal		= 1280 + 20 + 4 + 20,

		.flags	= DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC,
	},
	.bpc = 8,
	.format = MEDIA_BUS_FMT_RBG888_1X24,
	.on_cmds = radxa_10hd_init_cmd,
	.off_cmds = radxa_off_cmd,
	.num_init_cmds = sizeof(radxa_10hd_init_cmd)/sizeof(struct rockchip_panel_cmds),
};

static struct rockchip_panel_cmds radxa_10fhd_init_cmd[] = {
	{ .data = {0x05,0x78,0x01,0x11 } } ,
	{ .data = {0x05,0x14,0x01,0x29 } },
};

static struct radxa_panel_desc radxa_panel_desc_10fhd = {
	.mode = {
		.clock		= 160000,

		.hdisplay	= 1200,
		.hsync_start	= 1200 + 60,
		.hsync_end	= 1200 + 60 + 20,
		.htotal		= 1200 + 60 + 80 + 20,

		.vdisplay	= 1920,
		.vsync_start	= 1920 + 25,
		.vsync_end	= 1920 + 35 + 4,
		.vtotal		= 1920 + 25 + 4 + 35,

		.flags	= DRM_MODE_FLAG_NHSYNC | DRM_MODE_FLAG_NVSYNC,
	},

	.bpc = 8,
	.format = MEDIA_BUS_FMT_RBG888_1X24,
	.on_cmds = radxa_10fhd_init_cmd,
	.off_cmds = radxa_off_cmd,
	.num_init_cmds = sizeof(radxa_10fhd_init_cmd)/sizeof(struct rockchip_panel_cmds),
};


static int rockchip_panel_send_dsi_cmds(struct mipi_dsi_device *dsi,
					struct rockchip_panel_cmds *cmds,int len)
{
	int i, ret;
	if (!cmds)
		return -EINVAL;

	int cmd_cnt = len;
	printf("%s... %d\n",__func__,cmd_cnt);

	for (i = 0; i < cmd_cnt; i++) {
		switch (cmds[i].data[0]) {
			case MIPI_DSI_COMPRESSION_MODE:
				ret = mipi_dsi_compression_mode(dsi, cmds[i].data[3]);
				break;
			case MIPI_DSI_GENERIC_SHORT_WRITE_0_PARAM:
			case MIPI_DSI_GENERIC_SHORT_WRITE_1_PARAM:
			case MIPI_DSI_GENERIC_SHORT_WRITE_2_PARAM:
			case MIPI_DSI_GENERIC_LONG_WRITE:
				ret = mipi_dsi_generic_write(dsi, &cmds[i].data[3],
								 cmds[i].data[2]);
				break;
			case MIPI_DSI_DCS_SHORT_WRITE:
			case MIPI_DSI_DCS_SHORT_WRITE_PARAM:
			case MIPI_DSI_DCS_LONG_WRITE:
				ret = mipi_dsi_dcs_write_buffer(dsi, &cmds[i].data[3],
								 cmds[i].data[2]);
				break;
			default:
				printf("unsupport command data type: %d\n",
					   cmds[i].data[0]);
				return -EINVAL;
		}

		if (ret < 0) {
			printf("failed to write cmd%d: %d\n", i, ret);
			return ret;
		}

		if (cmds[i].data[1])
			mdelay(cmds[i].data[1]);
	}

	return 0;
}

static void panel_simple_prepare(struct rockchip_panel *panel)
{

	struct rockchip_panel_priv *priv = dev_get_priv(panel->dev);
	struct mipi_dsi_device *dsi = dev_get_parent_platdata(panel->dev);
	struct radxa_panel_desc *desc = priv->desc;

	printf("%s....\n",__func__);

	if (priv->prepared)
		return;

	if (priv->power_supply)
		regulator_set_enable(priv->power_supply, 1);

	if (priv->vccio)
		regulator_set_enable(priv->vccio, 1);

	if (priv->vdd)
		regulator_set_enable(priv->vdd, 1);

	if (dm_gpio_is_valid(&priv->enable_gpio))
		dm_gpio_set_value(&priv->enable_gpio, 1);

	mdelay(10);

	if (dm_gpio_is_valid(&priv->reset_gpio))
		dm_gpio_set_value(&priv->reset_gpio, 0);

	mdelay(10);

	if (dm_gpio_is_valid(&priv->reset_gpio))
		dm_gpio_set_value(&priv->reset_gpio, 1);

	mdelay(10);

	rockchip_panel_send_dsi_cmds(dsi, desc->on_cmds,desc->num_init_cmds);

	priv->prepared = true;
}

static void panel_simple_unprepare(struct rockchip_panel *panel)
{
	struct rockchip_panel_priv *priv = dev_get_priv(panel->dev);
	struct mipi_dsi_device *dsi = dev_get_parent_platdata(panel->dev);
	struct radxa_panel_desc *desc = priv->desc;

	printf("%s....\n",__func__);

	if (!priv->prepared)
		return;

	rockchip_panel_send_dsi_cmds(dsi, desc->off_cmds,2);
	mdelay(10);

	if (dm_gpio_is_valid(&priv->reset_gpio))
		dm_gpio_set_value(&priv->reset_gpio, 0);

	if (dm_gpio_is_valid(&priv->enable_gpio))
		dm_gpio_set_value(&priv->enable_gpio, 0);

	if (priv->power_supply)
		regulator_set_enable(priv->power_supply, 0);

	if (priv->vdd)
		regulator_set_enable(priv->vdd, 0);

	if (priv->vccio)
		regulator_set_enable(priv->vccio, 0);

	mdelay(10);
	priv->prepared = false;
}

static void panel_simple_enable(struct rockchip_panel *panel)
{
	struct rockchip_panel_priv *priv = dev_get_priv(panel->dev);

	printf("%s....\n",__func__);
	if (priv->enabled)
		return;

	if (priv->backlight)
		backlight_enable(priv->backlight);

	priv->enabled = true;
}

static void panel_simple_disable(struct rockchip_panel *panel)
{
	struct rockchip_panel_priv *priv = dev_get_priv(panel->dev);

	printf("%s....\n",__func__);
	if (!priv->enabled)
		return;

	if (priv->backlight)
		backlight_disable(priv->backlight);

	mdelay(10);

	priv->enabled = false;
}

static int panel_simple_get_modes(struct rockchip_panel *panel,struct drm_display_mode *mode)
{
	struct rockchip_panel_priv *priv = dev_get_priv(panel->dev);
	struct radxa_panel_desc *desc = priv->desc;

	memcpy(mode, &desc->mode, sizeof(struct drm_display_mode));
	mode->vrefresh = drm_mode_vrefresh(mode);

	return 0;
}

static const struct rockchip_panel_funcs rockchip_panel_funcs = {
	.prepare = panel_simple_prepare,
	.unprepare = panel_simple_unprepare,
	.enable = panel_simple_enable,
	.disable = panel_simple_disable,
	.get_mode = panel_simple_get_modes,
};

static int rockchip_panel_probe(struct udevice *dev)
{
	struct rockchip_panel_priv *priv = dev_get_priv(dev);
	struct rockchip_panel *panel;
	struct radxa_panel_desc *desc;
	int ret;

	desc =  (struct radxa_panel_desc *)dev_get_driver_data(dev);
	priv->desc = desc;
	ret = gpio_request_by_name(dev, "enable-gpios", 0,
				   &priv->enable_gpio, GPIOD_IS_OUT);
	if (ret && ret != -ENOENT) {
		printf("%s: Cannot get enable GPIO: %d\n", __func__, ret);
		return ret;
	}

	ret = gpio_request_by_name(dev, "reset-gpios", 0,
				   &priv->reset_gpio, GPIOD_IS_OUT);
	if (ret && ret != -ENOENT) {
		printf("%s: Cannot get reset GPIO: %d\n", __func__, ret);
		return ret;
	}

	ret = uclass_get_device_by_phandle(UCLASS_PANEL_BACKLIGHT, dev,
					   "backlight", &priv->backlight);
	if (ret && ret != -ENOENT) {
		printf("%s: Cannot get backlight: %d\n", __func__, ret);
		return ret;
	}

	ret = uclass_get_device_by_phandle(UCLASS_REGULATOR, dev,
					   "power-supply", &priv->power_supply);
	if (ret && ret != -ENOENT) {
		printf("%s: Cannot get power supply: %d\n", __func__, ret);
		return ret;
	}

	ret = uclass_get_device_by_phandle(UCLASS_REGULATOR, dev,
					   "vdd-supply", &priv->vdd);
	if (ret && ret != -ENOENT) {
		printf("%s: Cannot get vdd supply: %d\n", __func__, ret);
		return ret;
	}

	ret = uclass_get_device_by_phandle(UCLASS_REGULATOR, dev,
					   "vccio-supply", &priv->vccio);
	if (ret && ret != -ENOENT) {
		printf("%s: Cannot get power supply: %d\n", __func__, ret);
		return ret;
	}

	if (priv->cmd_type == CMD_TYPE_SPI) {
		ret = gpio_request_by_name(dev, "spi-sdi-gpios", 0,
					   &priv->spi_sdi_gpio, GPIOD_IS_OUT);
		if (ret && ret != -ENOENT) {
			printf("%s: Cannot get spi sdi GPIO: %d\n",
			       __func__, ret);
			return ret;
		}
		ret = gpio_request_by_name(dev, "spi-scl-gpios", 0,
					   &priv->spi_scl_gpio, GPIOD_IS_OUT);
		if (ret && ret != -ENOENT) {
			printf("%s: Cannot get spi scl GPIO: %d\n",
			       __func__, ret);
			return ret;
		}
		ret = gpio_request_by_name(dev, "spi-cs-gpios", 0,
					   &priv->spi_cs_gpio, GPIOD_IS_OUT);
		if (ret && ret != -ENOENT) {
			printf("%s: Cannot get spi cs GPIO: %d\n",
			       __func__, ret);
			return ret;
		}
		dm_gpio_set_value(&priv->spi_sdi_gpio, 1);
		dm_gpio_set_value(&priv->spi_scl_gpio, 1);
		dm_gpio_set_value(&priv->spi_cs_gpio, 1);
		dm_gpio_set_value(&priv->reset_gpio, 0);
	}

	panel = calloc(1, sizeof(*panel));
	if (!panel)
		return -ENOMEM;

	dev->driver_data = (ulong)panel;
	panel->dev = dev;
	panel->bus_format = desc->format;
	panel->bpc = desc->bpc;
	panel->funcs = &rockchip_panel_funcs;

	return 0;
}

static const struct udevice_id rockchip_panel_ids[] = {
	{ .compatible = "radxa,display-8hd", .data = (ulong)&radxa_panel_desc_8hd },
	{ .compatible = "radxa,display-10hd", .data = (ulong)&radxa_panel_desc_10hd },
	{ .compatible = "radxa,display-10fhd", .data = (ulong)&radxa_panel_desc_10fhd },
	{}
};

U_BOOT_DRIVER(radxa_panel) = {
	.name = "radxa_panel",
	.id = UCLASS_PANEL,
	.of_match = rockchip_panel_ids,
	.probe = rockchip_panel_probe,
	.priv_auto_alloc_size = sizeof(struct rockchip_panel_priv),
};
